package com.qmth.teachcloud.mark.service;

import com.github.jeffreyning.mybatisplus.service.IMppService;
import com.qmth.teachcloud.mark.bean.archivescore.QuestionVo;
import com.qmth.teachcloud.mark.bean.dto.MarkAreaDto;
import com.qmth.teachcloud.mark.entity.MarkSubjectiveScore;

import java.util.List;
import java.util.Set;

/**
 * <p>
 * 主观题得分明细表 服务类
 * </p>
 *
 * @author xf
 * @since 2023-09-22
 */
public interface MarkSubjectiveScoreService extends IMppService<MarkSubjectiveScore> {

    List<MarkSubjectiveScore> listByStudentIdAndGroupNumber(Long studentId, Integer groupNumber);

    Set<Integer> listMainNumberByStudentIdAndUncalculate(Long studentId, boolean uncalculate);

    List<MarkSubjectiveScore> listByStudentIdAndUncalculate(Long studentId, boolean uncalculate);

    void deleteByStudentId(Long studentId);

    void deleteByExamIdAndPaperNumberAndGroupNumber(Long examId, String paperNumber, Integer groupNumber);

    List<QuestionVo> getSubjectiveVo(List<Long> studentIds);

    List<MarkSubjectiveScore> listByStudentId(Long studentId);

    void updateRejected(Long studentId, Integer groupNumber, boolean rejectd);

    /**
     * 根据学生id查找评卷区
     *
     * @param studentId
     * @return
     */
    List<MarkAreaDto> findMarkArea(Long studentId);
}
